<template>
  <q-layout view="hHh lpR fFf">

    <q-header elevated class="bg-primary text-white">
      <q-toolbar>
        <q-toolbar-title>
          <q-avatar>
            <img src="~assets/bch.svg">
          </q-avatar>
          <router-link to="/">ScanToPay.Cash</router-link>
        </q-toolbar-title>
      </q-toolbar>
    </q-header>

    <q-page-container>
      <q-page class="flex justify-center">
        <q-form @submit="saveSettings" class="flex column text-center" style="flex-basis: 100%">
          <div class="column" style="height:100%">
            <q-banner class="flex col-shrink bg-dark text-white q-mb-lg q-pa-md">
              <strong>Setup your Terminal</strong>
            </q-banner>
            <div class="flex col-grow items-start justify-center sensible-width">
              <div class="q-form q-gutter-lg" style="width:100%">
                <p>To setup your terminal, simply complete the fields below.</p>

                <p>The destination address that you need to paste here is what is known as the "Receiving Address" in your Wallet App.</p>

                <p>If you do not yet have a Bitcoin Cash Wallet App installed, we recommend using the <span class="text-secondary">Bitcoin.com Wallet</span> which can be downloaded for free using the buttons below.</p>

                <div class="text-center">
                  <a href="https://apps.apple.com/us/app/bitcoin-wallet-by-bitcoin-com/id1252903728?ls=1" target="_blank" class="q-ma-sm">
                    <img src="https://www.bitcoin.com/static/app-store-download-9f203d83e2653968a9a208bd726b358d.png">
                  </a>
                  <a href="https://play.google.com/store/apps/details?id=com.bitcoin.mwallet" target="_blank" class="q-ma-sm">
                    <img src="https://www.bitcoin.com/static/google-play-download-394ca35f45c6e1611dcc764033734d4a.png" />
                  </a>
                </div>

                <q-input
                  v-model="settings.memo"
                  label="Merchant Name"
                  hint="Enter your store name"
                  :rules="[val => !!val || 'Field is required']"
                  outlined
                />

                <q-input
                  v-model="settings.payoutAddress"
                  label="Destination Address"
                  placeholder="bitcoincash:..."
                  hint="To find your destination address, open your Wallet App and select Bitcoin Cash. Then click the Receive button and paste the address starting with 'bitcoincash:' that appears on that screen into the field here"
                  :rules="[val => isValidCashAddr(val) || 'Must be a valid Bitcoin Cash address']"
                  outlined
                  @update:model-value="prefixAddress"
                />

                <CurrencySelect v-model="settings.currency" />
              </div>
            </div>
            <div class="col-shrink sensible-width">
              <div class="q-pa-sm">
                <q-btn push type="submit" label="Done" color="primary" class="full-width q-pa-md" icon="check_circle" />
              </div>
            </div>
          </div>
        </q-form>
      </q-page>
    </q-page-container>

  </q-layout>
</template>

<script setup lang="ts">
// Framework imports.
import { reactive } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import { useQuasar } from 'quasar'

// Local imports.
import type { Settings } from '../interfaces'
import { isValidCashAddr } from '../lib/utils'

// Component imports.
import CurrencySelect from '../components/CurrencySelect.vue'

// Third-party imports.
import axios from 'axios'

// Framework constants.
const $q = useQuasar()
const $route = useRoute()
const $router = useRouter()

// Local constants.
const terminalId = $route.params.terminalId
const terminalPassword = $route.query.pwd

// Define our reactive properties.
const settings = reactive<Settings>({
  memo: '',
  payoutAddress: '',
  currency: '',
  expiry: 300
})

async function saveSettings (): Promise<void> {
  try {
    // Show the loading indicator.
    $q.loading.show()

    // Send a post request to save the settings.
    await axios.post(`${process.env.API_URL}/terminal/${terminalId}/${terminalPassword}/settings`, settings)

    // Notify the user that the settings have been updated successfully.
    $q.notify({ type: 'positive', message: 'Terminal configured successfully!' })

    // Redirect user to the extras page.
    $router.push(`/t/${terminalId}/${terminalPassword}/extras`)
  } catch (err: any) {
    // Log the error to the console.
    console.log(err)

    // And notify the user.
    $q.notify({ type: 'negative', message: err.message })
  } finally {
    // Hide the loading indicator.
    $q.loading.hide()
  }
}

// prefix addresses with 'bitcoincash:' if not already prefixed
function prefixAddress (value: string): void {
  // Dont change incomplete address
  if (value.length !== 42 || !value.length) return

  if (!value.startsWith('bitcoincash:')) {
    settings.payoutAddress = `bitcoincash:${value}`
  }
}
</script>
